<?php

$rcmail = rcmail::get_instance();
$USERNAME = $rcmail->config->get('USERNAME');
$HOME = $rcmail->config->get('HOME');
$RUNAS_CMD = $rcmail->config->get('RUNAS_CMD');
$STF = $rcmail->config->get('STF');
$RESTORE = $rcmail->config->get('RESTORE');

?>

<h3 align="center">Restore</h3>

<?php

if (!isset($_POST['page'])) {

    /* This is where we decided the old snapshots will be. Brylon needs to fix this and make it configurable. */
    //$oldhome = preg_replace('|/rci/u|', '/oldrci/u', $HOME);
    $oldhome = $HOME;

    $exec_target = "$RUNAS_CMD $USERNAME $STF -A $oldhome/.snapshot";
    unset($result);
    exec($exec_target, $result, $status);

    /* Does the old .snapshot directory still exist? */
    if ($status == 0 && strcmp($result[0], 'type=directory') == 0) {

        $user_cmd = "find $oldhome/.snapshot/ -maxdepth 0 -type d -exec ls -ult '{}' \;";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";

        unset($result2);
        exec($exec_target, $result2, $status);

        $result2=array_unique($result2);
    
        /* List old .snapshot/{nightly.*, weekly.*} */
        if ($status == 0) {
            $options = NULL;
            foreach ($result2 as $_ => $val) {
                $tmp = preg_split("/\s+/", $val);
                if (count($tmp) < 9) {
                    continue;
                }
                $date = $tmp[5] . " " . $tmp[6];
                $datehr = $tmp[5] . " " . $tmp[6] . " " . $tmp[7];
                $dir = $tmp[8];
                if ((eregi('night', $dir) == 1) || (eregi('week', $dir) == 1) || (eregi('hour', $dir) == 1)) {
                    if (eregi('hour', $dir) == 1) {
                        $options .= "<option value=\"$oldhome/.snapshot/$dir/Maildir\">$datehr</option>";
                    }
                    else {
                        $options .= "<option value=\"$oldhome/.snapshot/$dir/Maildir\">$date</option>";
                    }
                }
            }
        }
    }
?>
    
    <div id="webtoolswebtools">
    Welcome <b><?=$USERNAME?></b>,
    <br>
    <br>
    This tool will restore one old mail folder at a time to a new folder called "RESTORE".
    <br>
    <br>
    If you already have a "RESTORE" folder, using this tool will replace it with the new restored folder you have selected. If you need to restore mail from more than one folder, restore one folder 
    first, retrieve the mail you need from it, then come back here and restore the next folder.
    <br>
    <br>
    Folders are available from the nightly backups of the past week, and the weekly backups of the past two months.
    </div>

    <br>
    <br>    

    <center>
    <form action="./?_task=dummy&_action=plugin.webtoolsrestore" method="post">
    View Maildir folders from:
    <select name="path">
    <?echo $options?>
    </select>
    <br>
    <br>
    <input type="hidden" name="page" value="show">
    <input type="submit" name="submit" value="Submit">
    </form>
    </center>
    
<?php
}
elseif($_POST['page'] == 'show') {
    
    $path = $_POST['path'];

    if (isset($path) && isset($HOME)) {
        $user_cmd = "find $path -maxdepth 0 -type d -exec ls -a '{}' \;";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        unset($result);
        exec($exec_target, $result, $status);

        $selects = NULL;
        for ($i=0,$numF=count($result);$i<$numF;$i++) {
            if (strcmp($result[$i],".") != 0 && strcmp($result[$i],"..") != 0) {
                if (strcmp(substr($result[$i],0,1),".") == 0) {
                    $entry = substr($result[$i],1);
                    $entry = preg_replace("/\./","/",$entry);
                    if (strcmp($entry,'RESTORE') == 0) {
                        continue;
                    }
                    $selects .= "<option value="."\"$entry\"".">".$entry."</option>";
                }
            }
        }
    } 
    else {
        die("Missing parameters.. Please try again");
    }
?>
    
    <center>
    <form action="./?_task=dummy&_action=plugin.webtoolsrestore" method="post">
    Please choose a folder:
    <br>
    <br>
    <select name="folder">
    <option value="INBOX">INBOX</option>
    <?echo $selects?>
    </select>
    <br>
    <br>
    <input type="hidden" name="path" value=<?=$path?>>
    <input type="hidden" name="page" value="restore">
    <input type="submit" name="submit" value="Submit">
    </form>
    </center>

<?php
}
elseif ($_POST['page'] == 'restore') {

    /* POST Variables */
    $path = $_POST['path'];
    $folder = $_POST['folder'];

    /* Declare and initialize local variables */
    $success = TRUE;
    $msg = '';
    $ln_Arr = NULL;

    if (isset($path) && isset($folder)) {
        if (strcmp($folder,"INBOX") != 0) {
            $newfolder = ".$folder";
            $newfolder = preg_replace("/\//",".",$newfolder);
        } 
        else {
            $newfolder = NULL;
        }

        if (strcmp($folder,"INBOX") != 0) {
            $newfolder = ".$folder";
            $newfolder = preg_replace("/\//",".",$newfolder);
        } else {
            $newfolder = NULL;
        }

        /* Try restoring mail folder */
        // Handle any folders that contain spaces
        $snapshot_dir = escapeshellarg("$path/$newfolder/$dir");
        $user_cmd = "$RESTORE $snapshot_dir";
        $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
        unset($result_arr);
        exec($exec_target, $result_arr, $status);
        $result_str = implode($result_arr);
        if (strpos($result_str, 'OK:') !== false) {
            $success = TRUE;
            //$msg = $result_str.'<br><br>';
        } 
        else {
            $success = FALSE;
            //$msg = $result_str.'<br>';
            $msg .= "Sorry the folder \"$folder\" could not be restored<br>";
        }
    } 
    else {
        $msg = 'Missing parameters.. Please try again.';
        $success = FALSE;
    }
    
    echo '<div id="webtoolswebtools">';
    if ($success) {
        $msg .= "Your mail folder: \"$folder\" has now been restored.<br><br>";
        $msg .= 'Use your favorite mail program to look for the new folder named "RESTORE".<br><br>';
        $msg .= 'You may have to "subscribe" to the new folder before your mail program can find it.';
        echo "<h4>Thank you $USERNAME,</h4>" , $msg;
    } 
    else {
        echo "<h4>Sorry $USERNAME,</h4>" , $msg;
    }
    echo '</div>';
}
else {
    die('Error: Invalid page type.');
}
?>
