<?php

require_once('plugins/webtools/webtools/functions.php');

if ($_POST['page'] == "Edit")
{
   $config['spamlevel'] = 4;
   if (have_file ("Maildir/mailfilter-spam", $result))
   {
      for ($i = 4; $i < count($result); $i++)
      {
         $line = $result[$i];
         if (strchr($line, '#') != false)
         {
            $line = str_replace (array("#", " "), "", $line);
            $vals = explode (':', $line);
            $config[$vals[0]] = $vals[1];
         }
      }
   }
   $config['cleanupdays'] = 14;
   if (have_file ("Maildir/mailfilter-autodeletedspam", $result))
   {
      if (strchr($result[5], '#') != false)
      {
         $result[5] = str_replace (array("#", " "), "", $result[5]);
         $vals = explode (':', $result[5]);
         $config[$vals[0]] = $vals[1];
      }
   }
   if (have_file ("Maildir/mailfilter-spam-blacklist", $result))
   {
      foreach ($result as $line)
      {
         if (strchr($line, '#'))
         {
            $line = str_replace (array("#", " "), "", $line);
            if (strstr($line, "blacklist-user"))
               $config['blacklist-addresses'][] = end(explode(':', $line));
            else if (strstr($line, "blacklist-domain"))
               $config['blacklist-domains'][] = end(explode(':', $line));
         }
      }
   }
   if (have_file ("Maildir/mailfilter-spam-whitelist", $result))
   {
      foreach ($result as $line)
      {
         if (strchr($line, '#'))
         {
            $line = str_replace (array("#", " "), "", $line);
            if (strstr($line, "whitelist-user"))
               $config['whitelist-addresses'][] = end(explode(':', $line));
            else if (strstr($line, "whitelist-domain"))
               $config['whitelist-domains'][] = end(explode(':', $line));
         }
      }
   }
   if ($config['spamfolder'] == "AUTO-DELETED-SPAM")
   {
      $config['ourfolder'] = true;
      $config['spamfolder'] = "";
   }
   else if ($config['spamfolder'] != "") $config['folder'] = true;
   else if ($config['spamfolder'] == "") $config['delete'] = true;
?>
<div id="webtoolswebtools">
   <script type="text/javascript">
      $(function(){
         $('#slider').slider({
            slide: function(event, ui) { document.getElementById('level').value = ui.value; document.getElementById('slider-value').innerHTML=ui.value; },
            min: 1, max: 30, value: <?=$config['spamlevel']?>
         });
      });
   </script>
   <style> #slider .ui-slider-handle { border-color: #CCCCCC; background: #FEFEFE; } </style>
   <h3 align="center">Spam Filtering</h3>
   <form method="POST" action="?_task=dummy&_action=plugin.webtoolsspam">
      <div style="border:1px solid black; padding-left:10px; margin-bottom:25px;">
         <h4>Required Spam Filter Options</h4>
         <p>
            A spam filter level of 5 is recommended unless you are choosing to delete mail tagged as spam; in this case the recommended
            level is 10.  The lower this number is, the stricter the spam filter will be.
         </p>
         <p>
            <input type='hidden' name='spamlevel' value='<?=$config['spamlevel']?>' id='level'>
            <div id="slider"style="width:90%;float:left"></div>
            <div style="text-align:center;" id="slider-value"><?=$config['spamlevel']?></div>
            <div style="width:90%">
               <div style="font-size:8px;float:left;">Strict</div>
               <div style="font-size:8px;float:right;">Lenient</div>
            </div>
         </p>
         <p>What would you like the filter to do with mail marked as spam?</p>
         <p>
            <input type='radio' name='tagged-spam' value='ourfolder' <?=($config['ourfolder']?"checked":"")?>>
            Store the spam in a folder called 'AUTO-DELETED-SPAM'. 
            Keep it for <input type='text' name='ourfolder-dayskeep' size=3 maxlength=3 value='<?=$config['cleanupdays']?>'> days.
         </p>
         <p>
            <input type='radio' name='tagged-spam' value='folder' <?=($config['folder']?"checked":"")?>>
            Store the spam in this folder:
            <input type='text' name='spam-folder' size=15 maxlength=25 value='<?=$config['spamfolder']?>'>
         </p>
         <p>
            <input type='radio' name='tagged-spam' value='delete' <?=($config['delete']?"checked":"")?>>
            Delete the spam.
         </p>
      </div>
      <div style="border:1px solid black; padding-left: 10px; margin-bottom:15px;">
         <h4>Optional Filters</h4>
         <div id="blacklist-address">
            <p>
               <input type="button" value="+" onclick="add_input('blacklist-address')">
               Always treat mail from these addresses as spam:
            </p>
            <?php
               foreach ($config['blacklist-addresses'] as $address)
                  echo ('<p><input type="text" name="blacklist-address[]" size=40 maxlength=129 value="'.$address.'"></p>');
            ?>
         </div>
         <div id="blacklist-domain">
            <p><input type="button" value="+" onclick="add_input('blacklist-domain')"> Always treat mail from these domains as spam:</p>
            <?php
               foreach ($config['blacklist-domains'] as $address)
                  echo ('<p><input type="text" name="blacklist-domain[]" size=40 maxlength=129 value="'.$address.'"></p>');
            ?>
         </div>
         <div id="whitelist-address">
            <p><input type="button" value="+" onclick="add_input('whitelist-address')"> Never treat mail from these addresses as spam:</p>
            <?php
               foreach ($config['whitelist-addresses'] as $address)
                  echo ('<p><input type="text" name="whitelist-address[]" size=40 maxlength=129 value="'.$address.'"></p>');
            ?>
         </div>
         <div id="whitelist-domain">
            <p><input type="button" value="+" onclick="add_input('whitelist-domain')"> Never treat mail from these domains as spam:</p>
            <?php
               foreach ($config['whitelist-domains'] as $address)
                  echo ('<p><input type="text" name="whitelist-domain[]" size=40 maxlength=129 value="'.$address.'"></p>');
            ?>
         </div>
      </div>
      <input type='submit' name='page' value='Submit'>
   </form>
</div>
<?php
}
else if ($_POST['page'] == "Submit")
{
   $header  = "################################################\n";
   $header .= "# THIS FILE WAS CREATED BY A WEBTOOL.          #\n";
   $header .= "# DO NOT EDIT THIS FILE BY HAND.               #\n";
   $header .= "################################################\n\n";
   $files['mailfilter-spam'] = $header;
   $files['mailfilter-spam'] .= "#spamlevel: " . $_POST['spamlevel'] . "\nSPAMLEVEL='";
   for ($i=0; $i<intval($_POST['spamlevel']); $i++) $files['mailfilter-spam'] .= "*";
   $files['mailfilter-spam'] .= "'\n";
   $files['mailfilter-spam'] .= "#spamfolder: ";
   if ($_POST['tagged-spam'] == "folder") $files['mailfilter-spam'] .= $_POST['spam-folder'] . "\n" . "SPAMFOLDER='" . $_POST['spam-folder'] . "'\n";
   else if ($_POST['tagged-spam'] == "delete") $files['mailfilter-spam'] .= "\nSPAMFOLDER=''\n";
   else if ($_POST['tagged-spam'] == "ourfolder") 
   {
      $files['mailfilter-spam'] .= "AUTO-DELETED-SPAM" . "\n" . "SPAMFOLDER='AUTO-DELETED-SPAM'\n";
      $files['mailfilter-autodeletedspam'] = $header . "#cleanupdays: " . $_POST['ourfolder-dayskeep'] . "\n" . $_POST['ourfolder-dayskeep'];
   }
   $files['mailfilter-spam-blacklist'] = $header;
   foreach ($_POST['blacklist-address'] as $address)
   {
      if (empty($address)) break;
      $files['mailfilter-spam-blacklist'] .= "#blacklist-user: " . $address . "\n";
      $address = str_replace (".", "\.", $address);
      $files['mailfilter-spam-blacklist'] .= "^" . $address . "\n";
   }
   foreach ($_POST['blacklist-domain'] as $domain)
   {
      if (empty($domain)) break;
      $files['mailfilter-spam-blacklist'] .= "#blacklist-domain: " . $domain . "\n";
      $domain = str_replace (".", "\.", $domain);
      $domain .= "\n";
      $subdomain = "@.*\." . $domain;
      $domain = "@" . $domain;
      $files['mailfilter-spam-blacklist'] .= $domain . $subdomain;
   }
   $files['mailfilter-spam-whitelist'] = $header;
   foreach ($_POST['whitelist-address'] as $address)
   {
      if (empty($address)) break;
      $files['mailfilter-spam-whitelist'] .= "#whitelist-user: " . $address . "\n";
      $address = str_replace (".", "\.", $address);
      $files['mailfilter-spam-whitelist'] .= "^" . $address . "\n";
   }
   foreach ($_POST['whitelist-domain'] as $domain)
   {
      if (empty($domain)) break;
      $files['mailfilter-spam-whitelist'] .= "#whitelist-domain: " . $domain . "\n";
      $domain = str_replace (".", "\.", $domain);
      $domain .= "\n";
      $subdomain = "@.*\." . $domain;
      $domain = "@" . $domain;
      $files['mailfilter-spam-whitelist'] .= $domain . $subdomain;
   }
   foreach ($files as $filename => $contents)
   {
      write_file ("Maildir/" . $filename, $contents);
   }
?>
<div id="webtoolswebtools">
   <h3 align="center">Spam Filtering</h3>
   <p>Settings successfully saved.</p>
</div>
<?php
}
else 
{
?>
<div id="webtoolswebtools">
   <h3 align="center">Spam Filtering</h3>
   <p>
Rutgers spamfilter usage <a STYLE="font-size: large"
href="http://www.nbcs.rutgers.edu/newdocs/spamfilter/spamfilter.php3"
target="_blank">  detailed documentation</a>
</p>
<h3>Rutgers spamfilter description:</h3>
<p> 
Spam is a name for unwanted email, usually advertisements. However, what
is unwanted to one person may be welcome to another, so there are no
universal criteria for filtering out spam system-wide. Contrast this with
email viruses, which are always unwelcome and have unique patterns. Our
implementation of spam filtering does not actually filter the spam, but
instead only tags each mail message with a score for how much it looks
like spam.
</p>
<p>
This tool allows you to look at the score a message received and decides
what to do with messages that have a score value higher than the value you
chose.  For example, we recommend that people start off setting this
filter level to 5 and have any messages that score a
5 or higher delivered into a folder called AUTO-DELETED-SPAM.
You can look at this folder to see if any false positives have occurred - that
is, to see if any wanted mail has been placed here by accident.  You can then
adjust the filter trigger value as needed, depending on your personal
definition of what score would constitute spam.  You can also allow specific
users or domains to not be considered spam, or to always be allowed.  This is
known as whitelisting or blacklisting by user or by domain.  Note that
whitelisting or blacklisting takes precedence, i.e. if you say "ALWAYS treat
mail from domain.com as SPAM" then those messages will be filtered regardless
of the score.
</p>
<p>
Every night, we will delete all messages that are older than a certain
number of days from an account's AUTO-DELETED-SPAM folder.  You can set
the number of days, between 1 and 30,
in the filter.  You can, of course, delete the messages in this folder
yourself more frequently.
</p>
<p> 
As you gain more experience in how the spam filter operates, you may
choose to have it automatically delete messages that score above a certain
value, or those from a certain domain, or user.  Be warned that, if you
cause a legitimate message to be deleted immediately, we have no way of
getting that message back.  For this reason, you should use the "Delete
the spam" option cautiously.
</p>
<p>
The spam filter software we have installed is based on the popular <a
href="http://spamassassin.org">SpamAssassin</a> program.  All incoming
messages are scored according to complex formulas as to the likelihood of
their being spam.  For example, if a message Subject mentions Viagra, it
gets a score of +2.896.  If it was sent by the Pine mail program (which
spammers hardly ever use), it gets a +0.001.  These scores are all added
together and a final value assigned to the message. <a
href="http://spamassassin.org/tests.html">A list of the criteria used and
scores assigned</a> may be found on the <a
href="http://spamassassin.org">SpamAssassin</a> web site.
</p>
<p>
If you have any questions about the use of the filter, you may write to
the address help on your system (e.g., help@eden, help@rci), or you may
call the RUCS Help Desk at 732-445-4357 (HELP).
</p>
   <form method="post" action="?_task=dummy&_action=plugin.webtoolsspam">
   <input type='submit' name='page' value='Edit'>
   </form>
</div>
<?php
}
?>
