<?php

//require_once('plugins/webtools/webtools/config.php');
require_once('plugins/webtools/webtools/functions.php');
$rcmail = rcmail::get_instance();
$HOME = $rcmail->config->get('HOME');
$USERNAME = $rcmail->config->get('USERNAME');
$RUNAS_CMD = $rcmail->config->get('RUNAS_CMD');
$MF = $rcmail->config->get('MF');
$STF = $rcmail->config->get('STF');
$USERINFO = $rcmail->config->get('USERINFO');

?>

<div id="webtoolswebtools">
<h3 align="center">Hush Quota</h3>

<? if (!isset($_POST['page'])) {

echo <<< HTML
<blockquote>
Use this tool to control whether or not this account receives messages
warning that it is near or at its quota limit.
<p>
<center>
    <form method="post" action="./?_task=dummy&_action=plugin.webtoolshushquota">
        <input type="submit" name="page" value="setup" title="Setup hush quota">
        <input type="submit" name="page" value="disable" title="Disable hush quota">
    </form>
</center>
<p>
Click "Setup hush" to STOP receiving such messages.
</br>
Click "Disable hush" to START receiving such messages again.
<p>
The "hush" feature is disabled by default.  That is, if you take no action,
you will receive an e-mail warning when you are approaching your account's
quota. Use this tool only if you want to stop such messages ("hush" them).
<p>
The quota warnings are special messages which cannot be forwarded to
another account.  Even if you forward all your other mail off of this
account, you will only see these messages if you look at this account's
Inbox.
</blockquote>
HTML;

} elseif ($_POST['page'] == 'setup'){

$success = false;

/* Create the file (w/ timestamp) we will check for in maildroprc */
$user_cmd = "$MF Maildir/RU-HUSH-QUOTA";
$exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
unipipe_exec($exec_target, date('Ymd-U')."\n");

/* Verify the file was created (stupid way of doing it...) */
$user_cmd = "$STF Maildir/RU-HUSH-QUOTA";
$exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
exec($exec_target, $result, $status);
if ($status == 0) {
    $success = true;
}

if ($success) {
    print <<<HTML
    <h4>Thank you $USERNAME,</h4>
    You will no longer receive mail when you are approaching your account's quota.
HTML;
} else {
    print <<<HTML
    <h4>Sorry $USERNAME,</h4>
    Tried to enable hushquota, but failed.
HTML;
}

} elseif ($_POST['page'] == 'disable'){
$found = false;
$success = false;

if (have_file("Maildir/RU-HUSH-QUOTA",$result)) {
    $found = true;
    $file = "Maildir/RU-HUSH-QUOTA";
    $user_cmd = "find $HOME -maxdepth 2 -path $HOME/$file -exec rm -f '{}' \;";
    //$user_cmd = "$RMF Maildir/RU-HUSH-QUOTA";
    $exec_target = "$RUNAS_CMD $USERNAME $user_cmd";
    exec($exec_target, $result, $status);
    if ($status == 0) {
        $success = true;
    }
}

if ($found && $success) {
    print <<<HTML
    <h4>Thank you $USERNAME,</h4>
    You will now receive mail when you are approaching your account's quota.
HTML;
} else {
    if (!$found) {
        $msg = "No reason to disable hushquota since it appears you never enabled it.<br />";
    } else {
        $msg = "Tried to disable hushquota, but failed. <br />";
    }
    print <<<HTML
    <h4>Sorry $USERNAME,</h4>
    $msg
HTML;
}

}
?>
</div>
